unit Enum;

//Une Cration originale de denis bertin amliore par denis bertin son concepteur.
//Qui selon la perception de denis bertin est aussi une visiblit internautesque avec la bonne formulation Html.
//Amliorer par denis bertin le 11.6.2013 pour afficher les disques prsent sur le systme.
//Ecrit par denis bertin stphane pour ajouter une zone de mmorisation d'un rpertoire avec la taille des fichiers le 14 juin 2013.
//Ajout par denis bertin stphane de la date des fichiers ainsi numr dans un rpertoire de choix avec des jokers hypothtiques ? le 14 juin 2013*
//Les caractres ? et * sont des caractres Joker le point d'intrrogation remplace indiframment un caractres alors que l'toile en replace plusieurs quelqu'ils soient.
//Enumration d'un grouper de rpertoire, le 10-11.12.2013 Finit ? 


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ShellCtrls, StdCtrls, Grids, Outline, DirOutln,
  ExtCtrls, Menus, Buttons, MPlayer;

const k_title_application='Enum Files';

(*
Suite  la demande de romain qui m'a demand comment crer un bouton et ce code qui me permet d'extraire les fichier d'un rpertoire.
Voici un exemple de positionnement d'un bouton, d'une tree-liste et d'un contrle d'dition le masque de recherche.
Ce programme permet de slectionner un rpertoire et d'exporter dans un fichier les noms des fichier correspondants au masque.
Une seule mthode est dfinit quand vous cliquez sur le bouton de lancement qui demande au pralable de saisir un nom de fichier.
Ce nom de fichier est utilis pour crire (writeln) les noms correspondants  la recherche effectue. (c) Beelog crit par denis bertin. le 2.1.2012
*)

type
  TForm_dir_file_enum = class(TForm)
    Button1: TButton;
    DirectoryOutline1: TDirectoryOutline;
    SaveDialog1: TSaveDialog;
    Label1: TLabel;
    Edit1: TEdit;
    RadioButton_exporter_as_text: TRadioButton;
    RadioButton_exporter_as_html: TRadioButton;
    CheckBox_ordonner: TCheckBox;
    Timer1: TTimer;
    Button2: TButton;
    PopupMenuItems: TPopupMenu;
    Clic: TMenuItem;
    SpeedButton2: TSpeedButton;
    RadioButton_create_a_string_list: TRadioButton;
    CheckBox_File_size: TCheckBox;
    CheckBox_Time_stamp: TCheckBox;
    MediaPlayer: TMediaPlayer;
    CheckBox_indiquer_la_duree: TCheckBox;
    CheckBox_parcourir_les_dossiers: TCheckBox;
    Label2: TLabel;
    ProgressBar1: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure Pour_ce_fichier(var File_out_dir:TextFile; Directory_name,Avec_ce_fichier:string; Search: TSearchRec);
    procedure Pour_ce_repertoire(var File_out_dir:TextFile; directory_name:string);
    procedure Recurse_sub_directory;
    procedure Enumerer_les_fichiers_du_repertoire;
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ClicClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Dclarations prives }
    somme:integer;
  public
    { Dclarations publiques }
  end;

var
  Form_dir_file_enum: TForm_dir_file_enum;

implementation

{$R *.dfm}

uses Unit_aide,string_show_dialog;

type pc1024 = array [0..1024] of char;

function open_fichier_avec_extension(awindow:hwnd; ext,fichier:pchar):boolean;
  var a_jpeg_key,a_prog_key,a_shell_key:HKEY;
      pc_jpeg,pc_prog,pc_remplacer:pc1024;
      pc_show_filename_file_associated:pc1024;
      longeur,maxlen_remplacer:integer;
      p,q:pchar;
  begin
  result:=false;
  if RegOpenKey(HKEY_CLASSES_ROOT,ext,a_jpeg_key)=ERROR_SUCCESS then
    begin {ouverture de la cl jpeg}
    longeur:=pred(Sizeof(pc_jpeg));
    if RegQueryValue(a_jpeg_key,nil,pc_jpeg,longeur)=ERROR_SUCCESS then
      begin
      if RegOpenKey(HKEY_CLASSES_ROOT,pc_jpeg,a_prog_key)=ERROR_SUCCESS then
        begin
        if (RegOpenKey(a_prog_key,'shell\edit\command',a_shell_key)=ERROR_SUCCESS)
        or (RegOpenKey(a_prog_key,'shell\open\command',a_shell_key)=ERROR_SUCCESS) then
          begin
          longeur:=pred(Sizeof(pc_prog));
          if RegQueryValue(a_shell_key,nil,pc_prog,longeur)=ERROR_SUCCESS then
            begin
            p:=sysutils.strpos(pc_prog,'.exe');
            if p=nil then p:=sysutils.strpos(pc_prog,'.EXE');
            if p<>nil then
              begin
               p:=strpos(pc_prog,'%1');
              if p<>nil then
                begin
                maxlen_remplacer:=pred(sizeof(pc_remplacer));
                strcopy(pc_show_filename_file_associated,'Voulez-vous ouvrir ce fichier avec le logiciel associ : "%s" ?');
                SysUtils.StrLFmt(pc_remplacer,maxlen_remplacer,pchar(@pc_show_filename_file_associated),[pc_jpeg]);
                if application.MessageBox(pc_remplacer,k_title_application, MB_YESNO)=IDYES then
                  begin
                  if awindow<>0 then
                    updatewindow(awindow);
                  q:=p; dec(q);
                  if q^='"' then
                    begin
                    p^:=#0;
                    strcat(strcat(pc_prog,fichier),'"');
                    end
                  else
                    begin
                    p^:=#0;
                    strcat(strcat(strcat(pc_prog,' "'),fichier),'"');
                    end;
                  {$ifdef debug}if application.MessageBox(pc_prog,z_open_file.string_previsualisation,MB_YESNO)=IDYES then {$endif debug}
                    result:=winexec(pc_prog,sw_show)>=32;
                  end
                end
              else
                begin
                maxlen_remplacer:=pred(sizeof(pc_remplacer));
                strcopy(pc_show_filename_file_associated,'Voulez-vous ouvrir ce fichier avec le logiciel associ : "%s" ?');
                SysUtils.StrLFmt(pc_remplacer,maxlen_remplacer,pchar(@pc_show_filename_file_associated),[pc_jpeg]);
                if application.MessageBox(pc_remplacer,k_title_application,MB_YESNO)=IDYES then
                  begin
                  if awindow<>0 then
                    updatewindow(awindow);
                  //Exception pour paint shop pro suppr chaine /dde
                  p:=strpos(pc_prog,'/dde');
                  if p<>nil then
                    p^:=#0;
                  strcat(strcat(strcat(pc_prog,' "'),fichier),'"');
                  {$ifdef debug} if application.MessageBox(pc_prog,z_open_file.string_previsualisation,MB_YESNO)=IDYES then {$endif debug}
                    result:=winexec(pc_prog,sw_show)>=32;
                  end;
                end;
              end;
            end;
            RegCloseKey(a_shell_key);
          end;
          RegCloseKey(a_prog_key);
          end;
          end;
        RegCloseKey(a_jpeg_key);
      end;  {ouverture de la cl jpeg}
  end; {open_fichier_avec_extension}


procedure TForm_dir_file_enum.Button1Click(Sender: TObject);
  begin
  Self.Enumerer_les_fichiers_du_repertoire;
  end;

procedure Obtenir_la_duree(time:integer; var Minute,Seconde:integer);
  var SecondeTotal:integer;
  begin
  SecondeTotal := time div 1000;  // transformation de milliseconde en seconde
  Minute := (SecondeTotal div 60);  // en divise les seconde par 60 = minutes
  Seconde := (SecondeTotal mod 60);
  end;

procedure get_duration(time:integer; var duration:string);
  var Minute,Seconde:integer;
  begin
  Obtenir_la_duree(time,Minute,Seconde);
  duration:=inttostr(Minute);
  if length(inttostr(Seconde))=1 then
    duration:=duration+':0'+inttostr(Seconde)
  else
    duration:=duration+':'+inttostr(Seconde);
  end;

procedure TForm_dir_file_enum.Pour_ce_fichier(var File_out_dir:TextFile; Directory_name,Avec_ce_fichier:string; Search: TSearchRec);
  var duration:string;
  begin
  if self.RadioButton_create_a_string_list.Checked then
    begin
    if self.CheckBox_indiquer_la_duree.Checked then
      begin
      if (strpos(pchar(Avec_ce_fichier),'.mp3')<>nil)
      or (strpos(pchar(Avec_ce_fichier),'.wma')<>nil)
      or (strpos(pchar(Avec_ce_fichier),'.wav')<>nil)
      or (strpos(pchar(Avec_ce_fichier),'.MP3')<>nil)
      or (strpos(pchar(Avec_ce_fichier),'.WMA')<>nil)
      or (strpos(pchar(Avec_ce_fichier),'.WAV')<>nil) then
        begin
          try
          MediaPlayer.FileName:=Directory_name+'\'+Avec_ce_fichier;
          MediaPlayer.Open;
          get_duration(MediaPlayer.TrackLength[1],duration);
          except
            end;
          string_show_dialog.Form_du_listing.Memo1.Lines.Add(Avec_ce_fichier+' '+duration);
        end;
      end
    else if self.CheckBox_Time_stamp.Checked and CheckBox_File_size.Checked then
      begin
      inc(somme,Search.Size);
      string_show_dialog.Form_du_listing.Memo1.Lines.Add(
        Avec_ce_fichier+' Avec une date '+DateTimeToStr(Search.Time)+
        ' taille='+inttostr(Search.Size)+' Octet(s)');
      end
    else if self.CheckBox_Time_stamp.Checked then
      begin
      string_show_dialog.Form_du_listing.Memo1.Lines.Add(
        Avec_ce_fichier+' Avec une date '+DateTimeToStr(Search.Time));
      end
    else if self.CheckBox_File_size.Checked then
      begin
      inc(somme,Search.Size);
      string_show_dialog.Form_du_listing.Memo1.Lines.Add(
        Avec_ce_fichier+' Taille='+inttostr(Search.Size)+' Octet(s)')
      end
    else
      string_show_dialog.Form_du_listing.Memo1.Lines.Add(Avec_ce_fichier);
    end
  else if self.CheckBox_indiquer_la_duree.Checked then
    begin
    if (strpos(pchar(Avec_ce_fichier),'.mp3')<>nil)
    or (strpos(pchar(Avec_ce_fichier),'.wma')<>nil)
    or (strpos(pchar(Avec_ce_fichier),'.wav')<>nil)
    or (strpos(pchar(Avec_ce_fichier),'.MP3')<>nil)
    or (strpos(pchar(Avec_ce_fichier),'.WMA')<>nil)
    or (strpos(pchar(Avec_ce_fichier),'.WAV')<>nil) then
      begin
      try
      MediaPlayer.FileName:=Directory_name+'\'+Avec_ce_fichier;
      MediaPlayer.Open;
      get_duration(MediaPlayer.TrackLength[1],duration);
      if self.RadioButton_exporter_as_text.Checked then
        writeln(File_out_dir,chr(9)+Avec_ce_fichier+' '+duration)
      else if self.RadioButton_exporter_as_html.Checked then
        begin
        if self.CheckBox_ordonner.Checked then
          writeln(File_out_dir,chr(9)+'<li>'+Avec_ce_fichier+' '+duration+'<br>')
        else
          writeln(File_out_dir,Avec_ce_fichier+' '+duration+'<br>');
        end;
      except
        end;
      end
    else
      begin
      if self.RadioButton_exporter_as_html.Checked then
        begin
        if self.CheckBox_ordonner.Checked then
          writeln(File_out_dir,chr(9)+'<li>'+Avec_ce_fichier+'<br>')
        else
          writeln(File_out_dir,Avec_ce_fichier+'<br>');
        end
      else
        writeln(File_out_dir,Avec_ce_fichier);
      end;
    end
  else if self.CheckBox_ordonner.Checked then
    begin
    if self.RadioButton_exporter_as_text.Checked then
      writeln(File_out_dir,chr(9)+Avec_ce_fichier)
    else if self.RadioButton_exporter_as_html.Checked then
      writeln(File_out_dir,chr(9)+'<li>'+Avec_ce_fichier+'<br>');
    end
  else
    begin
    if self.RadioButton_exporter_as_text.Checked then
      writeln(File_out_dir,Avec_ce_fichier)
    else if self.RadioButton_exporter_as_html.Checked then
      writeln(File_out_dir,Avec_ce_fichier+'<br>');
    end;
  end; {TForm_dir_file_enum.Pour_ce_fichier}

procedure TForm_dir_file_enum.Pour_ce_repertoire(var File_out_dir:TextFile; directory_name:string); {crit par Bertin denis}
  var apc:pc1024;
      Search: TSearchRec;
  begin
  if self.RadioButton_exporter_as_text.Checked then
    begin
    writeln(File_out_dir,'Nom du disque : '+Directory_name);
    end
  else if self.RadioButton_exporter_as_html.Checked then
    begin
    writeln(File_out_dir,'Nom du disque : '+Directory_name+'<br>');
    if self.CheckBox_ordonner.Checked then
      writeln(File_out_dir,'<ol>');
    end
  else if self.RadioButton_create_a_string_list.Checked then
    begin
    string_show_dialog.Form_du_listing.Memo1.Lines.Add('Nom du disque : '+Directory_name);
    end;
  strcat(strpcopy(apc,directory_name),pchar('\'+Edit1.Text));
  if findfirst(apc,faAnyfile,Search) = 0 then
    begin
    repeat
      if Search.Name[1]<>'.' then
        Self.Pour_ce_fichier(File_out_dir,Directory_name,Search.Name,Search);
    until FindNext(Search) <> 0;
    FindClose(Search);
    end;
  if self.CheckBox_ordonner.Checked then
    writeln(File_out_dir,'</ol>');
  end; {TForm_dir_file_enum.Pour_ce_repertoire}

procedure TForm_dir_file_enum.Recurse_sub_directory;
  var File_out_dir:TextFile;
      apc:array[0..1024] of char;
      Search: TSearchRec;
      maximum:integer;
      une_entree:string;
      une_liste:classes.TStringList;
  begin
  if self.RadioButton_exporter_as_text.Checked then
    begin
    SaveDialog1.DefaultExt := '.txt';
    SaveDialog1.Filter:='*.txt';
    if SaveDialog1.Execute then
      begin
      AssignFile(File_out_dir,SaveDialog1.FileName);
      ReWrite(File_out_dir);
      writeln(File_out_dir,'A partir du rpertoire : '+DirectoryOutline1.Directory);
      strcopy(apc,pchar(DirectoryOutline1.Directory));
      strcat(apc,pchar('\*.*')); //Denis B une toile
      maximum:=0;
      if findfirst(apc,faDirectory,Search) = 0 then
        begin
        repeat
          if Search.Name[1]<>'.' then
            if Search.Attr and faDirectory=faDirectory then
              inc(maximum);
        until FindNext(Search) <> 0;
        FindClose(Search);
        end;
      ProgressBar1.Visible:=true;
      ProgressBar1.Max:=maximum;
      ProgressBar1.Position:=0;
      if findfirst(apc,faDirectory,Search) = 0 then
        begin
        repeat
        if Search.Name[1]<>'.' then
          if Search.Attr and faDirectory=faDirectory then
            begin
            ProgressBar1.Position:=ProgressBar1.Position+1;
            Self.Pour_ce_repertoire(File_out_dir,DirectoryOutline1.Directory+'\'+Search.Name);
            end;
        until FindNext(Search) <> 0;
        FindClose(Search);
        end;
      ProgressBar1.Visible:=false;
      CloseFile(File_out_dir);
      Open_fichier_avec_extension(self.handle,'.txt',pchar(SaveDialog1.FileName));
      end;
    end
  else if self.RadioButton_exporter_as_html.Checked then
    begin
    SaveDialog1.Filter:='*.htm';
    SaveDialog1.DefaultExt := '.html';
    if SaveDialog1.Execute then
      begin
      AssignFile(File_out_dir,SaveDialog1.FileName);
      ReWrite(File_out_dir);
      writeln(File_out_dir,'//Un logiciel crit par Denis Bertin.<br>');
      writeln(File_out_dir,'//Le rpertoire qui est numr : '+DirectoryOutline1.Directory+'<br>');
      writeln(File_out_dir,'//Avec le masque des caractres jokers suivant : <code><font color="blue" size="3">'+Edit1.Text+'</font></code><br>');
      strcopy(apc,pchar(DirectoryOutline1.Directory));
      strcat(apc,pchar('\*.*')); //Denis B une toile
      maximum:=0;
      if findfirst(apc,faDirectory,Search) = 0 then
        begin
        repeat
          if Search.Name[1]<>'.' then
            if Search.Attr and faDirectory=faDirectory then
              inc(maximum);
        until FindNext(Search) <> 0;
        FindClose(Search);
        end;
      ProgressBar1.Visible:=true;
      ProgressBar1.Max:=maximum;
      ProgressBar1.Position:=0;
      if findfirst(apc,faDirectory,Search) = 0 then
        begin
        repeat
        if Search.Name[1]<>'.' then
          if Search.Attr and faDirectory=faDirectory then
            begin
            ProgressBar1.Position:=ProgressBar1.Position+1;
            Self.Pour_ce_repertoire(File_out_dir,DirectoryOutline1.Directory+'\'+Search.Name);
            end;
        until FindNext(Search) <> 0;
        FindClose(Search);
        end;
      ProgressBar1.Visible:=false;
      CloseFile(File_out_dir);
      end;
    Open_fichier_avec_extension(self.handle,'.htm',pchar(SaveDialog1.FileName));
    end
  else if self.RadioButton_create_a_string_list.Checked then
    begin
    strcopy(apc,pchar(DirectoryOutline1.Directory));
    strcat(apc,pchar('\*.*')); //Denis B une toile
    maximum:=0;
    if findfirst(apc,faDirectory,Search) = 0 then
      begin
        repeat
          if Search.Name[1]<>'.' then
            if Search.Attr and faDirectory=faDirectory then
              inc(maximum);
        until FindNext(Search) <> 0;
      FindClose(Search);
      end;
    ProgressBar1.Visible:=true;
    ProgressBar1.Max:=maximum;
    ProgressBar1.Position:=0;
    string_show_dialog.Form_du_listing.Memo1.clear;
    if findfirst(apc,faDirectory,Search) = 0 then
      begin
      repeat
      if Search.Name[1]<>'.' then
        if Search.Attr and faDirectory=faDirectory then
          begin
          ProgressBar1.Position:=ProgressBar1.Position+1;
          Self.Pour_ce_repertoire(File_out_dir,DirectoryOutline1.Directory+'\'+Search.Name);
          end;
      until FindNext(Search) <> 0;
      FindClose(Search);
      ProgressBar1.Visible:=false;
      string_show_dialog.Form_du_listing.ShowModal;
      end;
    end;
  end; {TForm_dir_file_enum.Eecurse_sub_directory}

procedure TForm_dir_file_enum.Enumerer_les_fichiers_du_repertoire;
  var i:integer;
  var apc:pc1024;
  var Search: TSearchRec;
  var File_out_dir:TextFile;
  var une_liste:classes.TStringList;
  var une_entree:string;
  var duration:string;
  begin
  {$ifdef debug}
    box(0,pchar(DirectoryOutline1.Directory));
  {$endif debug}
  if self.CheckBox_parcourir_les_dossiers.Checked then
    begin
    Self.Recurse_sub_directory;
    end
  else
    if self.RadioButton_exporter_as_text.Checked then
      begin
      SaveDialog1.DefaultExt := '.txt';
      SaveDialog1.Filter:='*.txt';
      if SaveDialog1.Execute then
        begin
        AssignFile(File_out_dir,SaveDialog1.FileName);
        ReWrite(File_out_dir);

        strcopy(apc,pchar(DirectoryOutline1.Directory));
        strcat(apc,pchar('\'+Edit1.Text));
        if findfirst(apc,faAnyFile,Search) = 0 then
          begin
            repeat
            //Pour viter que ces fichiers de remont de rpertoire soit list (. et ..)
            if Search.Name[1]<>'.' then
              self.Pour_ce_fichier(File_out_dir,DirectoryOutline1.Directory,Search.Name,Search);
            until FindNext(Search) <> 0;
          FindClose(Search);
          end;
        CloseFile(File_out_dir);
        Open_fichier_avec_extension(self.handle,'.txt',pchar(SaveDialog1.FileName));
        end
      end
  else if self.RadioButton_exporter_as_html.Checked then
    begin
    SaveDialog1.Filter:='*.htm';
    SaveDialog1.DefaultExt := '.html';
    if SaveDialog1.Execute then
      begin
      AssignFile(File_out_dir,SaveDialog1.FileName);
      ReWrite(File_out_dir);
      writeln(File_out_dir,'//Le rpertoire qui est numr : '+DirectoryOutline1.Directory+'<br>');
      writeln(File_out_dir,'//Avec le masque des caractres jokers suivant : '+Edit1.Text+'<br>');
      strcopy(apc,pchar(DirectoryOutline1.Directory));
      strcat(apc,pchar('\'+Edit1.Text));
      if findfirst(apc,faAnyFile,Search) = 0 then
        begin
        if self.CheckBox_ordonner.Checked then
          writeln(File_out_dir,'<ol>');
        repeat
        //Pour viter que ces fichiers de remont de rpertoire soit list (. et ..)
        if Search.Name[1]<>'.' then
          begin
          Self.Pour_ce_fichier(File_out_dir,DirectoryOutline1.Directory,Search.Name,Search);
          end;
        until FindNext(Search) <> 0;
        FindClose(Search);
        if self.CheckBox_ordonner.Checked then
          writeln(File_out_dir,'</ol>');
        end;
      CloseFile(File_out_dir);
      Open_fichier_avec_extension(self.handle,'.htm',pchar(SaveDialog1.FileName));
      end;
    end
  else if self.RadioButton_create_a_string_list.Checked then
    begin
    une_liste:=classes.TStringList.Create;
    strcat(strcopy(apc,pchar(DirectoryOutline1.Directory)),pchar('\'+Edit1.Text));
    string_show_dialog.Form_du_listing.Memo1.clear;
    if findfirst(apc,faAnyFile,Search) = 0 then
      begin
      {initialisation de la variable somme}
      somme:=0;
      repeat
        if Search.Name[1]<>'.' then
          begin
          une_entree:=Search.Name;
          une_liste.add(une_entree);
          self.Pour_ce_fichier(File_out_dir,DirectoryOutline1.Directory,Search.Name,Search);
          end;
      until FindNext(Search) <> 0;
      if CheckBox_File_size.Checked then
        string_show_dialog.Form_du_listing.Memo1.Lines.Add(
          'Nombre de fichier du rpertoire '+
          DirectoryOutline1.Directory+' est gal  '+inttostr(une_liste.count)+
          ' Avec une taille total = '+inttostr(somme)+' Octet(s)')
      else
        string_show_dialog.Form_du_listing.Memo1.Lines.Add(
          'Nombre de fichier du rpertoire '+
          DirectoryOutline1.Directory+' est gal  '+inttostr(une_liste.count));
      FindClose(Search);
      string_show_dialog.Form_du_listing.ShowModal;
      une_liste.Free;
      end;
    end;
  end;

procedure TForm_dir_file_enum.Timer1Timer(Sender: TObject);
begin
CheckBox_ordonner.Visible:=self.RadioButton_exporter_as_html.Checked;
CheckBox_File_size.Visible:=self.RadioButton_create_a_string_list.Checked;
CheckBox_Time_stamp.Visible:=self.RadioButton_create_a_string_list.Checked;
end;

procedure TForm_dir_file_enum.FormActivate(Sender: TObject);
begin
self.RadioButton_exporter_as_text.Checked:=true;
end;

procedure TForm_dir_file_enum.Button2Click(Sender: TObject);
var Drive: Char;
   pc_idrive:array[0..255] of char;
   apoint:tpoint;
   NewItem: TMenuItem;
  begin
  PopupMenuItems.Items.clear;
  getcursorpos(apoint);
	{parcourir les diffrentes lettres pour trouver les disques}
  for Drive := 'a' to 'z' do
  begin
    strcopy(pc_idrive,PChar(Drive + ':\'));
    case GetDriveType(pc_idrive) of
			0:;
			DRIVE_REMOVABLE,DRIVE_FIXED,DRIVE_REMOTE:
				begin {OK}
        NewItem := TMenuItem.Create(PopupMenuItems); // crer le nouvel lment
        PopupMenuItems.Items.Add(NewItem);// lui ajouter le Popupmenu
        NewItem.Caption := pc_idrive;
        NewItem.Tag := ord(drive)-ord('a');
        NewItem.OnClick := ClicClick;
				end; {OK}
			end; {case}
		end; {for}
  with apoint do
    PopupMenuItems.Popup(X, Y);
  end;

procedure TForm_dir_file_enum.ClicClick(Sender: TObject);
begin
///Attribuer la bonne lettre du lecteur
with Sender as TMenuItem do
  DirectoryOutline1.Drive:=chr(ord(Tag)+ord('a'));
end;

procedure TForm_dir_file_enum.SpeedButton2Click(Sender: TObject);
begin
Unit_aide.Form_aide.ShowModal;
end;

end.

